﻿Imports Infragistics.Win.Misc

Public Class Form1
    Dim hasError As Boolean = False

    Dim ABC As New List(Of TextBox)()
    Dim XYZ As New List(Of TextBox)()


    Public Sub New()
        InitializeComponent()

        UltraValidator1.NotificationSettings.Action = Infragistics.Win.Misc.NotificationAction.Image
        ABC.Add(textBoxA)
        ABC.Add(textBoxB)
        ABC.Add(textBoxC)

        XYZ.Add(textBoxX)
        XYZ.Add(textBoxY)
        XYZ.Add(textBoxZ)

        For Each control As Control In Me.Controls
            control.CausesValidation = True
        Next
    End Sub

    Private Sub MakeValueRequired(ultraValidator As Infragistics.Win.Misc.UltraValidator, textFields As List(Of TextBox))
        ultraValidator.ValidationGroups.Clear()
        Dim requiredFieldsGroup As ValidationGroup = ultraValidator.ValidationGroups.Add("Required")

        Dim count As Integer = If(textFields IsNot Nothing, textFields.Count, 0)
        For i As Integer = 0 To count - 1
            Dim textBox As TextBox = textFields(i)
            Dim validationSettings As ValidationSettings = ultraValidator.GetValidationSettings(textBox)
            validationSettings.Reset()
            validationSettings.ValidationGroup = requiredFieldsGroup
            validationSettings.ValidationTrigger = ValidationTrigger.Programmatic
            validationSettings.ValidationPropertyName = "Text"
            validationSettings.IsRequired = True
        Next

        AddHandler ultraValidator.ValidationError, AddressOf OnRequiredFieldValidationError


    End Sub

    Private Sub ValidateRequired(requiredFieldsGroup As ValidationGroup)
        Dim ultraValidator As UltraValidator = requiredFieldsGroup.UltraValidator
        ultraValidator.Validate(requiredFieldsGroup, True, False)
    End Sub

    Private Sub OnRequiredFieldValidationError(sender As Object, e As ValidationErrorEventArgs)
        hasError = True
    End Sub

    Private Sub UltraOptionSet1_ValueChanged(sender As System.Object, e As System.EventArgs) Handles UltraOptionSet1.ValueChanged
        Select Case UltraOptionSet1.Value.ToString()
            Case "visible"
                UltraButton1.Show()
                clearNotRequired(UltraValidator1, ABC)
                ValidateRequired(UltraValidator1.ValidationGroups(0))

                MakeValueRequired(UltraValidator1, XYZ)
                ValidateRequired(UltraValidator1.ValidationGroups(0))

                UltraValidator1.ResetValidationGroups()


                Exit Select
            Case "hidden"
                UltraButton1.Hide()
                clearNotRequired(UltraValidator1, XYZ)
                ValidateRequired(UltraValidator1.ValidationGroups(0))

                MakeValueRequired(UltraValidator1, ABC)
                ValidateRequired(UltraValidator1.ValidationGroups(0))

                UltraValidator1.ResetValidationGroups()

                Exit Select
        End Select
    End Sub


    Private Sub clearNotRequired(ultraValidator As UltraValidator, textFields As List(Of TextBox))
        ultraValidator.ValidationGroups.Clear()
        Dim requiredFieldsGroup As ValidationGroup = ultraValidator.ValidationGroups.Add("Required")

        Dim count As Integer = If(textFields IsNot Nothing, textFields.Count, 0)
        For i As Integer = 0 To count - 1
            Dim textBox As TextBox = textFields(i)
            Dim validationSettings As ValidationSettings = ultraValidator.GetValidationSettings(textBox)
            validationSettings.Reset()
            validationSettings.ValidationGroup = requiredFieldsGroup
            validationSettings.IsRequired = False
        Next
    End Sub



    Private Sub UltraButton1_Click(sender As System.Object, e As System.EventArgs) Handles UltraButton1.Click
        Select Case UltraOptionSet1.Value.ToString()
            Case "visible"
                UltraButton1.Show()
                clearNotRequired(UltraValidator1, ABC)
                ValidateRequired(UltraValidator1.ValidationGroups(0))

                MakeValueRequired(UltraValidator1, XYZ)
                ValidateRequired(UltraValidator1.ValidationGroups(0))

                UltraValidator1.ResetValidationGroups()


                Exit Select
            Case "hidden"
                UltraButton1.Hide()
                clearNotRequired(UltraValidator1, XYZ)
                ValidateRequired(UltraValidator1.ValidationGroups(0))

                MakeValueRequired(UltraValidator1, ABC)
                ValidateRequired(UltraValidator1.ValidationGroups(0))

                UltraValidator1.ResetValidationGroups()

                Exit Select
        End Select
    End Sub

    Dim hasLoaded As Boolean = False

    Private Sub UltraButton1_VisibleChanged(sender As System.Object, e As System.EventArgs) Handles UltraButton1.VisibleChanged


        If Not UltraButton1.Visible AndAlso hasLoaded Then
            MakeValueRequired(UltraValidator1, ABC)
            ValidateRequired(UltraValidator1.ValidationGroups(0))
            UltraValidator1.ResetValidationGroups()

        ElseIf UltraButton1.Visible AndAlso hasLoaded Then
            MakeValueRequired(UltraValidator1, XYZ)
            ValidateRequired(UltraValidator1.ValidationGroups(0))
            UltraValidator1.ResetValidationGroups()
        End If
    End Sub


    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        hasLoaded = True

    End Sub

    Private Sub UltraValidator1_Validating(sender As System.Object, e As Infragistics.Win.Misc.ValidatingEventArgs) Handles UltraValidator1.Validating
        If e.IsValid Then
            hasError = False
        End If
    End Sub


    Private Sub Form1_FormClosing(sender As System.Object, e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        If hasError Then
            e.Cancel = True
        End If
    End Sub
End Class
